/*
** Copyright (C) 2003 The Free Software Foundation.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef INCLUDED_MAINWINDOW_H
#define INCLUDED_MAINWINDOW_H


#include <gtk/gtk.h>
#include "configuration.h"
#include "track.h"
#include "book.h"
//#include "backup.h"
#include "undo.h"
#include "windowscompanionlocal.h"
#include "windowscompanionremote.h"
#include "scripture.h"
#include "ustring.h"


class MainWindow
{
public:
  MainWindow ();
  virtual ~ MainWindow ();
  virtual int run ();
  // Widgets from Glade
  GtkWidget * mainwindow;
protected:
  GtkWidget * vbox1;
  GtkWidget *menubar1;
  /* IMPORTANT If more menu items are added see whether they should be made 
   * in(sensitive) depending on whether a project has been opened. */
  GtkWidget *menuitem_file;
  GtkWidget *menuitem_file_menu;
  GtkWidget *file_project;
  GtkWidget *image463;
  GtkWidget *file_project_menu;
  GtkWidget *new1;
  GtkWidget *open1;
  GtkWidget *close1;
  GtkWidget *delete1;
  GtkWidget *properties1;
  GtkWidget *import1;
  GtkWidget *image464;
  GtkWidget *file_references;
  GtkWidget *image465;
  GtkWidget *file_references_menu;
  GtkWidget *open_references1;
  GtkWidget *image466;
  GtkWidget *references_save_as;
  GtkWidget *close_references;
  GtkWidget *image468;
  GtkWidget *delete_references;
  GtkWidget *image469;
  GtkWidget *quit1;
  GtkWidget *menuitem_edit;
  GtkWidget *menuitem_edit_menu;
  GtkWidget *cut1;
  GtkWidget *copy1;
  GtkWidget *paste1;
  GtkWidget *separator2;
  GtkWidget *undo1;
  GtkWidget *image295;
  GtkWidget *redo1;
  GtkWidget *image296;
  GtkWidget *separator4;
  GtkWidget *find1;
  GtkWidget *find_and_replace1;
  GtkWidget *findspecial1;
  GtkWidget *image313;
  GtkWidget *menuitem_view;
  GtkWidget *menuitem_view_menu;
  GtkWidget *font1;
  GtkWidget *menuitem_goto;
  GtkWidget *menuitem_goto_menu;
  GtkWidget *next_verse1;
  GtkWidget *image95;
  GtkWidget *previous_verse1;
  GtkWidget *image96;
  GtkWidget *next_chapter1;
  GtkWidget *image97;
  GtkWidget *previous_chapter1;
  GtkWidget *image98;
  GtkWidget *next_book1;
  GtkWidget *image99;
  GtkWidget *previous_book1;
  GtkWidget *image100;
  GtkWidget *next_reference1;
  GtkWidget *image608;
  GtkWidget *previous_reference1;
  GtkWidget *image609;
  GtkWidget *reference1;
  GtkWidget *image101;
  GtkWidget *menuitem_tools;
  GtkWidget *menuitem_tools_menu;
  GtkWidget *convert_project_to_web_pages1;
  GtkWidget *image102;
  GtkWidget *menuitem_preferences;
  GtkWidget *menuitem_preferences_menu;
  GtkWidget *bibledit_windows_companion1;
  GtkWidget *image103;
  GtkWidget *languages1;
  GtkWidget *image104;
  GtkWidget *stylesheets1;
  GtkWidget *image105;
  GtkWidget *menuitem_diagnostics;
  GtkWidget *menuitem_diagnostics_menu;
  GtkWidget *view_system_log1;
  GtkWidget *image106;
  GtkWidget *menuitem_help;
  GtkWidget *menuitem_help_menu;
  GtkWidget *help1;
  GtkWidget *about1;
  GtkWidget *image107;
  GtkWidget *toolbar1;
  GtkWidget *button_back;
  GtkWidget *image1;
  GtkWidget *button_forward;
  GtkWidget *image2;
  GtkWidget *combo_book;
  GtkWidget *combo_entry_book;
  GtkWidget *combo_chapter;
  GtkWidget *combo_entry_chapter;
  GtkWidget *combo_verse;
  GtkWidget *combo_entry_verse;
  GtkWidget *hbox1;
  GtkWidget *hpaned1;
  GtkWidget *vpaned1;
  GtkWidget *scrolledwindow1;
  GtkWidget *textview_edit;
  GtkWidget *scrolledwindow3;
  GtkWidget *textview_notes;
  GtkWidget *scrolledwindow2;
  GtkWidget *treeview1;
  GtkWidget *statusbar1;
  GtkAccelGroup *accel_group;
  // Gtk variables manually added.
  GtkTextBuffer *textbuffer_edit;
  GtkTextBuffer *textbuffer_notes;
  gint statusbar_context_id;
  GtkListStore *liststore;
  GtkTreeViewColumn *treecolumn;
  GtkTreeSelection *treeselect;
  GtkTextTag *editor_line_tag;

  /* Initialization */
  virtual void initialize_project ();
  virtual void enable_or_disable_widgets (bool enable);

  /* Menu callbacks */
  static void on_open1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void open ();
  static void on_close1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void close ();
  static void on_new1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void newproject ();
  static void on_properties1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void editproject ();
  static void on_delete1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void deleteproject ();
  static void on_quit1_activate (GtkMenuItem * menuitem, gpointer user_data);
  static void on_convert_project_to_web_pages1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void convert2web ();
  static void on_view_system_log1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void viewlog ();
  static void on_help1_activate (GtkMenuItem * menuitem, gpointer user_data);
  static void on_about1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void showabout ();
  static void on_undo1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_undo ();
  static void on_redo1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_redo ();
  static void on_edit1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_edit ();
  static void on_find1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_find ();
  static void on_find_and_replace1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_replace ();
  static void on_findspecial1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_findspecial ();
  static void on_bibledit_windows_companion1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void companion_settings ();
  static void on_font1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void editor_settings ();
  static void on_languages1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void language_settings ();
  static void on_stylesheets1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void stylesheet_settings ();
  static void on_import1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void menu_import ();
  static gboolean on_mainwindow_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data);
  /* Navigation  */
  static void on_combo_entry_book_changed (GtkEditable * editable, gpointer user_data);
  virtual void on_combo_book_changed ();
  static void on_combo_entry_chapter_changed (GtkEditable * editable, gpointer user_data);
  virtual void on_combo_chapter_changed ();
  static void on_combo_entry_verse_changed (GtkEditable * editable, gpointer user_data);
  virtual void on_combo_verse_changed ();
  static void on_next_verse1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_next_verse ();
  static void on_previous_verse1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_previous_verse ();
  static void on_next_chapter1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_next_chapter ();
  static void on_previous_chapter1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_previous_chapter ();
  static void on_next_book1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_next_book ();
  static void on_previous_book1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_previous_book ();
  static void on_reference1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void goto_reference ();
  virtual void go_to_reference (const string & gotobook, const string & gotochapter, const string & gotoverse, bool jump, bool highlight);
  bool go_to_reference_running;
  string editor_current_book, editor_current_chapter, editor_current_verse;
  static bool mainwindow_on_navigation_timeout (gpointer data);
  virtual bool on_navigation_timeout ();
  bool driving_book, driving_chapter, driving_verse;
  static void on_textview_edit_move_cursor (GtkTextView * textview, GtkMovementStep step, gint count, gboolean extend_selection, gpointer user_data);
  static bool mainwindow_on_cursor_moved_delayed (gpointer data);
  virtual void on_cursor_moved ();
  bool focus_programmatically_being_grabbed;
  static void on_textview_edit_grab_focus (GtkWidget * widget, gpointer user_data);
  virtual void on_grab_focus ();
  string cursor_get_verse_number ();
  unsigned int on_grab_focus_timer;
  string goto_cursor_position;
  unsigned int navigation_change_timer;
  string navigator_current_book, navigator_current_chapter, navigator_current_verse;
  static bool mainwindow_on_grab_focus_delayed_handler (gpointer data);
  bool on_grab_focus_delayed_handler ();
  void highlight_verse_at_cursor ();

  /* Tracker */
  static void on_button_forward_clicked (GtkButton * button, gpointer user_data);
  virtual void goto_next_reference ();
  static void on_button_back_clicked (GtkButton * button, gpointer user_data);
  virtual void goto_previous_reference ();
  virtual void set_next_or_previous_item (GtkCombo * combo, const string & current_text, bool next);
  vector < string > combo_book_popdown_strings;
  vector < string > combo_chapter_popdown_strings;
  vector < string > combo_verse_popdown_strings;
  virtual void set_sensitivity_of_navigator_buttons ();
  static bool mainwindow_on_tracker_timeout (gpointer data);
  virtual bool on_tracker_timeout ();
  virtual void set_next_or_previous_reference (bool next);
  Track track;

  /* Variables for general use */
  Configuration *configuration;
  Scripture *scripture;
  Book *navigator_book;

  /* Loading, editing, saving */
  Book *book;
  virtual void editor_load_chapter ();
  static bool mainwindow_editor_position_cursor_at_verse (gpointer data);
  virtual bool editor_position_cursor_at_verse ();
  virtual void editor_save ();
  static bool mainwindow_on_save_timeout (gpointer data);
  virtual bool on_save_timeout ();
  virtual void editor_set_font ();

  /* Clipboard */
  static void on_cut1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_cut ();
  static void on_copy1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_copy ();
  static void on_paste1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_paste ();

  /* Backups */
//  Backup backup;

  /* List store and reference handling */
  static gboolean on_treeview1_key_press_event (GtkWidget * widget, GdkEventKey * event, gpointer user_data);
  static gboolean on_treeview1_button_press_event (GtkWidget * widget, GdkEventButton * event, gpointer user_data);
  virtual void on_list_goto ();
  static void mainwindow_selection_foreach_function (GtkTreeModel * model, GtkTreePath * path, GtkTreeIter * iter, gpointer data);
  static void on_open_references1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_open_references ();
  string selected_reference;
  static void on_references_save_as_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_save_references ();
  static void on_close_references_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_clear_references ();
  static void on_delete_references_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_delete_references ();
  static void on_delete_reference (GtkTreeModel * model, GtkTreePath * path, GtkTreeIter * iter, gpointer data);
  static void on_next_reference1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_next_reference ();
  static void on_previous_reference1_activate (GtkMenuItem * menuitem, gpointer user_data);
  virtual void on_previous_reference ();
  GtkTextTag * editor_reference_tag;
  virtual void highlight_searchwords (int versenumber);
  virtual void highlight_searchwords_internal (unsigned int linenumber,
                                               unsigned int versenumber, const string & searchword, bool & cursor_set, bool & is_verse, bool casesensitive);
  vector < ustring > references_searchwords;
  vector < bool > references_casesensitives;
  bool navigator_highlight;

  /* Undo and Redo */
  Undo undo;
  static void on_textbuffer_edit_insert_text (GtkTextBuffer * textbuffer, GtkTextIter * arg1, gchar * arg2, gint arg3, gpointer user_data);
  virtual void on_insert (GtkTextBuffer * textbuffer, GtkTextIter * pos, const ustring & text, int bytes);
  static void on_textbuffer_edit_delete_text (GtkTextBuffer * textbuffer, GtkTextIter * arg1, GtkTextIter * arg2, gpointer user_data);
  virtual void on_erase (GtkTextBuffer * textbuffer, GtkTextIter * range_begin, GtkTextIter * range_end);

  /* Undo and Redo */
  static bool mainwindow_on_windows_companion_timeout (gpointer data);
  virtual bool on_windows_companion_timeout ();

  /* Bibledit Windows Companion */
  WindowsCompanionLocal windowscompanionlocal;
  WindowsCompanionRemote windowscompanionremote;

  /* Test development */
  virtual void on_test ();

};


#endif
